import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.Random;

public class Goobe extends Applet{

//
// Begin Variable Declarations
//

  // Question Frame Parameters
  private QuestionFrame questionFrame = null;
  private Dimension questionFrameSize = null;

  // Questions
  private String question[] = null;
  private int questionCount = 0;
  private int whichQuestion = 0;
  private int[] pick;

  private Color   questionFontColor = Color.white;

  // Answers
  private String answer[] = null;
  private int correctAnswer[] = null;

  // Media
  private Image questionBackgroundImg = null;
  private Font questionFont = null;

  private AudioClip audioAmbience = null;
  private AudioClip audioThrusters = null;
  private AudioClip audioCrash = null;

  // Game Frame Parameters
  private GameFrame gameFrame = null;
  private GameFrame gameFrameSize = null;

  private Image[] shipImg  = null;
  private Image[] winImg   = null;
  private int     winImgCount = 0;
  private Image   gameBackgroundImg = null; 
  private Image   gameBackgroundWinImg = null; 
  private Image   gameButtonImg = null; 
  private Font    gameFont = null;
  private Color   gameFontColor = Color.white;
  private Color   gameHilightColor = Color.yellow;
  private Color   gameInactiveColor = Color.darkGray;

//
// Methods
//
  
  public void update(Graphics g){
    paint(g);
  } // update
  
  public void init(){

    setLayout(new BorderLayout());

    // Background Image Parameters
    //
    // <PARAM NAME="GAME_BACKGROUND_IMAGE" VALUE="myimage.gif">
    // <PARAM NAME="GAME_BACKGROUND_WIN_IMAGE" VALUE="myimage.gif">
    // <PARAM NAME="QUESTION_BACKGROUND_IMAGE" VALUE="myimage.gif">
    // <PARAM NAME="GAME_SHIP_IMAGE_BASENAME" VALUE="myimage.gif">
    // <PARAM NAME="GAME_WIN_IMAGE_BASENAME" VALUE="myimage.gif">
    // <PARAM NAME="GAME_WIN_IMAGE_COUNT" VALUE="myimage.gif">
    // <PARAM NAME="GAME_BUTTON_IMAGE" VALUE="myimage.gif">
    // <PARAM NAME="GAME_AUDIO_AMBIENCE" VALUE="ambience.au">
    // <PARAM NAME="GAME_AUDIO_THRUSTERS" VALUE="thrusters.au">
    // <PARAM NAME="GAME_AUDIO_CRASH" VALUE="crash.au">
    //
    String questionBackgroundImgStr = getParameter("QUESTION_BACKGROUND_IMAGE");
    String gameBackgroundImgStr = getParameter("GAME_BACKGROUND_IMAGE");
    String gameBackgroundWinImgStr = getParameter("GAME_BACKGROUND_WIN_IMAGE");
    String gameShipImageBasenameStr = getParameter("GAME_SHIP_IMAGE_BASENAME");
    String gameWinImageBasenameStr = getParameter("GAME_WIN_IMAGE_BASENAME");
    String gameWinImageCountStr = getParameter("GAME_WIN_IMAGE_COUNT");
    String gameButtonImgStr = getParameter("GAME_BUTTON_IMAGE");

    String audioAmbienceStr = getParameter("GAME_AUDIO_AMBIENCE");
    String audioThrustersStr = getParameter("GAME_AUDIO_THRUSTERS");
    String audioCrashStr = getParameter("GAME_AUDIO_CRASH");
    
    if (questionBackgroundImgStr != null)
      questionBackgroundImg = getImage(getDocumentBase(), questionBackgroundImgStr);
    
    if (gameBackgroundImgStr != null)
      gameBackgroundImg = getImage(getDocumentBase(), gameBackgroundImgStr);

    if (gameBackgroundWinImgStr != null)
      gameBackgroundWinImg = getImage(getDocumentBase(), gameBackgroundWinImgStr);

    if (gameButtonImgStr != null)
      gameButtonImg = getImage(getDocumentBase(), gameButtonImgStr);

    if (gameShipImageBasenameStr != null){
      shipImg = new Image[GameFrame.SHIP_IMAGE_COUNT];

      for(int i=0;i<GameFrame.SHIP_IMAGE_COUNT;i++)
        shipImg[i] = getImage(getDocumentBase(),StringConversion.baseString(gameShipImageBasenameStr) + 
                              Integer.toString(i) + StringConversion.extString(gameShipImageBasenameStr));
    }

    if (gameWinImageBasenameStr != null){
      if (gameWinImageCountStr != null){
        winImgCount = StringConversion.string2Int(gameWinImageCountStr);

        winImg = new Image[winImgCount];

        for(int i=0;i<winImgCount;i++)
          winImg[i] = getImage(getDocumentBase(),StringConversion.baseString(gameWinImageBasenameStr) + 
                               Integer.toString(i) + StringConversion.extString(gameWinImageBasenameStr));
      }
    }

    if (audioAmbienceStr != null)
      audioAmbience = getAudioClip(getDocumentBase(), audioAmbienceStr);

    if (audioThrustersStr != null)
      audioThrusters = getAudioClip(getDocumentBase(), audioThrustersStr);

    if (audioCrashStr != null)
      audioCrash = getAudioClip(getDocumentBase(), audioCrashStr);

    // Question Frame Font Parameters
    //
    // <PARAM NAME="QUESTION_FONT" VALUE="TimesRoman32Italic|Bold">
    // <PARAM NAME="QUESTION_FONT_COLOR" VALUE="0, 0, 0">
    // <PARAM NAME="QUESTION_FRAME_SIZE" VALUE="20%">
    // <PARAM NAME="QUESTION_COUNT" VALUE="1">
    // <PARAM NAME="QUESTION_0" VALUE="Line 1|Line 2|Line3">
    // <PARAM NAME="ANSWER_0_A" VALUE="Choice 1">
    // <PARAM NAME="ANSWER_0_B" VALUE="Choice 1">
    // <PARAM NAME="ANSWER_0_C" VALUE="Choice 1">
    // <PARAM NAME="ANSWER_0_D" VALUE="Choice 1">
    // <PARAM NAME="QUESTION_0_ANSWER" VALUE="C">
    //
    String questionFontStr = getParameter("QUESTION_FONT");
    String questionFrameSizeStr = getParameter("QUESTION_FRAME_SIZE");
    String questionCountStr = getParameter("QUESTION_COUNT");
    String questionFontColorStr = getParameter("QUESTION_FONT_COLOR");
    
    if (questionFrameSizeStr != null)
      questionFrameSize = new Dimension(size().width, 
        size().height * StringConversion.string2Int(questionFrameSizeStr)/100);
    else
      questionFrameSize = new Dimension(size().width, size().height/3);
    
    if (questionFontStr != null)
      questionFont = StringConversion.string2Font(questionFontStr);
    else
      questionFont = new Font("TimesRoman", Font.ITALIC | Font.BOLD, 32);

    if (questionCountStr != null)
      questionCount = StringConversion.string2Int(questionCountStr);
    else
      questionCount = 0;

    if (questionCount != 0){
      question = new String[questionCount];
      answer   = new String[questionCount*4];
      correctAnswer = new int[questionCount];

      for(int i=0;i<questionCount;i++){
        question[i] = getParameter("QUESTION_" + Integer.toString(i));
	for(int j=0;j<4;j++)
          answer[i*4+j] = getParameter("ANSWER_" + Integer.toString(i) + "_" + (char) ('A' + j));
	correctAnswer[i] = (int) (getParameter("QUESTION_" + Integer.toString(i) + "_ANSWER").charAt(0) - 'A');
      }

      if (questionFontColorStr != null)
        questionFontColor = StringConversion.string2Color(questionFontColorStr);

      mixQuestions();

      questionFrame = new QuestionFrame(question[pick[whichQuestion]]);
      questionFrame.setBackgroundImage(questionBackgroundImg);
      questionFrame.setFont(questionFont);
      questionFrame.setForeground(questionFontColor);
      questionFrame.resize(questionFrameSize);
      add("North",questionFrame);
    }

    // Game Frame Font Parameters
    //
    // <PARAM NAME="GAME_FONT" VALUE="TimesRoman24Bold">
    // <PARAM NAME="GAME_FONT_COLOR" VALUE="0, 0, 0">
    // <PARAM NAME="GAME_HIGHLIGHT_COLOR" VALUE="0, 0, 0">
    // <PARAM NAME="GAME_INACTIVE_COLOR" VALUE="169, 169, 169">
    //
    String gameFontStr = getParameter("GAME_FONT");
    String gameFontColorStr = getParameter("GAME_FONT_COLOR");
    String gameHilightColorStr = getParameter("GAME_HILIGHT_COLOR");
    String gameInactiveColorStr = getParameter("GAME_INACTIVE_COLOR");

    if (gameFontStr != null)
      gameFont = StringConversion.string2Font(gameFontStr);
    else
      gameFont = new Font("TimesRoman",Font.BOLD,24);

    if (gameFontColorStr != null)
      gameFontColor = StringConversion.string2Color(gameFontColorStr);

    if (gameHilightColorStr != null)
      gameHilightColor = StringConversion.string2Color(gameHilightColorStr);

    if (gameInactiveColorStr != null)
      gameInactiveColor = StringConversion.string2Color(gameInactiveColorStr);

    gameFrame = new GameFrame(answer,pick[whichQuestion],
                              correctAnswer[pick[whichQuestion]]);
    gameFrame.setFont(gameFont);
    gameFrame.setForeground(gameFontColor);
    gameFrame.setSpecialColors(gameHilightColor, gameInactiveColor);
    gameFrame.setImages(shipImg,winImg,winImgCount,gameButtonImg);
    gameFrame.setAudio(audioThrusters, audioCrash);
    gameFrame.setBackgroundImages(gameBackgroundImg, gameBackgroundWinImg);
    add("Center", gameFrame);

    questionFrame.setGameFrame(gameFrame);

  } // init()

  public void mixQuestions(){
    pick = new int[questionCount];
    Random rand = new Random();

    for (int i=0;i<questionCount;i++)
      pick[i] = i;

    int which, val;
    for (int i=questionCount-1;i>1;i--){
      /* Debug
        System.err.println("Start");
	System.err.print("\t");
        for(int j=0;j<questionCount-1;j++)
          System.err.print(Integer.toString(pick[j]) + ",");
        System.err.println(pick[questionCount-1]);
      */
        
      which = Math.abs(rand.nextInt()%i);

      /* Debug
        System.err.print("Pick Sort: ");
        System.err.print("which(" + Integer.toString(which) + ") ");
      */

      val = pick[which];

      /* Debug
        System.err.println("val(" + Integer.toString(val) + ") ");
      */

      for (int j=which;j<i;j++){
        pick[j] = pick[j+1];
        /* Debug
          System.err.println("Moving:");
  	  System.err.print("\t");
          for(int k=0;k<questionCount-1;k++)
            System.err.print(Integer.toString(pick[k]) + ",");
          System.err.println(pick[questionCount-1]);
        */
      }
      pick[i] = val;

      /* Debug
        System.err.print("Done");
	System.err.print("\t");
        for(int j=0;j<questionCount-1;j++)
          System.err.print(Integer.toString(pick[j]) + ",");
        System.err.println(pick[questionCount-1]);
      */
    }
  }

  public boolean action(Event evt, Object arg){

    if (evt.target instanceof GameFrame)
      if (whichQuestion < questionCount - 1){
        whichQuestion++;
        ((GameFrame) evt.target).setAnswers(answer,pick[whichQuestion],
                                            correctAnswer[pick[whichQuestion]]);
        questionFrame.changeQuestion(question[pick[whichQuestion]]);
      }else{
        audioAmbience.stop();
	questionFrame.gameOver();
      }

    return true;
  }

  public void start(){
    audioAmbience.loop();
    if (questionFrame.running())
      questionFrame.start();
    if (gameFrame.running())
      gameFrame.start();
  } // start()

  public void stop(){
    audioAmbience.stop();
    if (questionFrame.running())
      questionFrame.stop();
    if (gameFrame.running())
      gameFrame.stop();
  } // stop()
    
} // Class Goobe










